# Written by Mads Engelund, 2017, http://espeem.com
import numpy
from ase.atoms import Atoms
from .AtomUtilities import *
from CalcTroll.Core.Test.Case import CalcTrollTestCase

import unittest

class AtomUtilitiesTest(CalcTrollTestCase):
    def testConvert(self):
        positions = numpy.array([[0,0,0], [0, 1/2., 3/2.]])
        unit_cell=[[1, 0, 0], [0, 1/2., 1/2.], [0, 0, 1/2.]]
        result, remainder = convertToBasis(positions, unit_cell)
        diff = result - [[0,0,0],[0,1,2]]
        self.assertAlmostEqual(sum(sum(abs(diff))), 0, 5)

        back_to_start = convertFromBasis(result, unit_cell)
        diff = back_to_start - positions
        self.assertAlmostEqual(sum(sum(abs(diff))), 0, 5)

    def testOrderAtoms(self):
        atoms = Atoms('Si84', [[  1.17975172e+00 ,  1.00694693e+00 ,  1.95803094e+00],
                               [ -1.20493611e+00 ,  1.00694693e+00 ,  1.95803094e+00],
                               [ -2.71228627e+00 ,  1.00694693e+00 ,  1.95803094e+00],
                               [ -5.09697409e+00 ,  1.00694693e+00 ,  1.95803094e+00],
                               [ -6.60432425e+00 ,  1.00694693e+00 ,  1.95803094e+00],
                               [ -8.98901208e+00 ,  1.00694693e+00 ,  1.95803094e+00],
                               [ -1.04963622e+01 ,  1.00694693e+00 ,  1.95803094e+00],
                               [ -1.28810501e+01 ,  1.00694693e+00 ,  1.95803094e+00],
                               [ -1.25921948e-02 ,  1.93182368e+00 ,  1.95803094e+00],
                               [ -3.90463018e+00 ,  1.93182368e+00 ,  1.95803094e+00],
                               [ -7.79666816e+00 ,  1.93182368e+00 ,  1.95803094e+00],
                               [ -1.16887061e+01 ,  1.93182368e+00 ,  1.95803094e+00],
                               [ -1.25921948e-02 ,  3.30786690e+00 ,  1.20119459e-02],
                               [ -3.90463018e+00 ,  3.30786690e+00 ,  1.20119459e-02],
                               [ -7.79666816e+00 ,  3.30786690e+00 ,  1.20119459e-02],
                               [ -1.16887061e+01 ,  3.30786690e+00 ,  1.20119459e-02],
                               [ -1.97436651e+00 ,  4.67741819e+00 ,  4.94956023e-03],
                               [ -5.83267759e+00 ,  4.67819758e+00 ,  4.89376487e-03],
                               [ -9.75844248e+00 ,  4.67741819e+00 ,  4.94956023e-03],
                               [ -1.36167536e+01 ,  4.67819758e+00 ,  4.89376487e-03],
                               [ -1.99407564e+00 ,  6.04878180e+00 ,  1.94942943e+00],
                               [ -5.80302656e+00 ,  6.04980102e+00 ,  1.94935562e+00],
                               [ -9.77815161e+00 ,  6.04878180e+00 ,  1.94942943e+00],
                               [ -1.35871025e+01 ,  6.04980102e+00 ,  1.94935562e+00],
                               [ -7.84740439e-03 ,  7.33057093e+00 ,  1.94117110e+00],
                               [ -7.80137471e+00 ,  7.32549318e+00 ,  1.96111611e+00],
                               [ -3.90456396e+00 ,  7.52407035e+00 ,  1.93721931e+00],
                               [ -1.16880553e+01 ,  7.51454856e+00 ,  1.93921758e+00],
                               [ -1.45666225e-02 ,  8.66400100e+00 , -7.19597428e-03],
                               [ -7.79696445e+00 ,  8.67177062e+00 ,  1.40240531e-02],
                               [ -3.90600732e+00 ,  8.93766938e+00 , -1.50438999e-02],
                               [ -1.16857149e+01 ,  8.94044397e+00 , -2.98672632e-03],
                               [ -1.84504370e+00 ,  1.01802856e+01 , -1.65871679e-02],
                               [ -5.94881391e+00 ,  1.02160688e+01 , -1.33639339e-01],
                               [ -9.64166549e+00 ,  1.02147309e+01 ,  1.05733814e-01],
                               [ -1.37510130e+01 ,  1.01795844e+01 , -1.13379432e-02],
                               [ -1.23121887e+00 ,  1.14084269e+01 ,  1.93083623e+00],
                               [ -6.84367598e+00 ,  1.09533464e+01 ,  1.92832188e+00],
                               [ -9.11105144e+00 ,  1.17320451e+01 ,  1.92763796e+00],
                               [ -1.43713391e+01 ,  1.14120921e+01 ,  1.93211591e+00],
                               [ -1.77660730e+00 ,  1.28341217e+01 ,  1.93322434e+00],
                               [ -1.38268731e+01 ,  1.28378159e+01 ,  1.93718917e+00],
                               [  1.17975172e+00 ,  1.00694693e+00 ,  5.85006892e+00],
                               [ -1.20493611e+00 ,  1.00694693e+00 ,  5.85006892e+00],
                               [ -2.71228627e+00 ,  1.00694693e+00 ,  5.85006892e+00],
                               [ -5.09697409e+00 ,  1.00694693e+00 ,  5.85006892e+00],
                               [ -6.60432425e+00 ,  1.00694693e+00 ,  5.85006892e+00],
                               [ -8.98901208e+00 ,  1.00694693e+00 ,  5.85006892e+00],
                               [ -1.04963622e+01 ,  1.00694693e+00 ,  5.85006892e+00],
                               [ -1.28810501e+01 ,  1.00694693e+00 ,  5.85006892e+00],
                               [ -1.25921948e-02 ,  1.93182368e+00 ,  5.85006892e+00],
                               [ -3.90463018e+00 ,  1.93182368e+00 ,  5.85006892e+00],
                               [ -7.79666816e+00 ,  1.93182368e+00 ,  5.85006892e+00],
                               [ -1.16887061e+01 ,  1.93182368e+00 ,  5.85006892e+00],
                               [ -1.25921948e-02 ,  3.30786690e+00 ,  3.90404993e+00],
                               [ -3.90463018e+00 ,  3.30786690e+00 ,  3.90404993e+00],
                               [ -7.79666816e+00 ,  3.30786690e+00 ,  3.90404993e+00],
                               [ -1.16887061e+01 ,  3.30786690e+00 ,  3.90404993e+00],
                               [ -1.97436651e+00 ,  4.67741819e+00 ,  3.89698754e+00],
                               [ -5.83267759e+00 ,  4.67819758e+00 ,  3.89693175e+00],
                               [ -9.75844248e+00 ,  4.67741819e+00 ,  3.89698754e+00],
                               [ -1.36167536e+01 ,  4.67819758e+00 ,  3.89693175e+00],
                               [ -1.99407564e+00 ,  6.04878180e+00 ,  5.84146742e+00],
                               [ -5.80302656e+00 ,  6.04980102e+00 ,  5.84139360e+00],
                               [ -9.77815161e+00 ,  6.04878180e+00 ,  5.84146742e+00],
                               [ -1.35871025e+01 ,  6.04980102e+00 ,  5.84139360e+00],
                               [ -7.49175882e-03 ,  7.33020111e+00 ,  5.83322378e+00],
                               [ -7.78266410e+00 ,  7.32418750e+00 ,  5.85266374e+00],
                               [ -3.89575388e+00 ,  7.51417629e+00 ,  5.82957461e+00],
                               [ -1.16783056e+01 ,  7.52710441e+00 ,  5.83169060e+00],
                               [ -1.24700168e-02 ,  8.66356658e+00 ,  3.88541624e+00],
                               [ -7.80029846e+00 ,  8.67393015e+00 ,  3.90681734e+00],
                               [ -3.90841779e+00 ,  8.93779218e+00 ,  3.88607263e+00],
                               [ -1.16879660e+01 ,  8.93986808e+00 ,  3.87600171e+00],
                               [ -1.84543864e+00 ,  1.01786295e+01 ,  3.87977081e+00],
                               [ -5.95366001e+00 ,  1.02135434e+01 ,  3.99559705e+00],
                               [ -9.64611559e+00 ,  1.02221884e+01 ,  3.75315744e+00],
                               [ -1.37514351e+01 ,  1.01811534e+01 ,  3.87643628e+00],
                               [ -1.22373373e+00 ,  1.14107772e+01 ,  5.82222549e+00],
                               [ -6.48518324e+00 ,  1.17208483e+01 ,  5.82314935e+00],
                               [ -8.75256419e+00 ,  1.09465605e+01 ,  5.81938893e+00],
                               [ -1.43636652e+01 ,  1.14104100e+01 ,  5.82455418e+00],
                               [ -1.76917957e+00 ,  1.28366016e+01 ,  5.82702019e+00],
                               [ -1.38190962e+01 ,  1.28360268e+01 ,  5.82767485e+00]],
                               cell=[100, 100, 100])

        atoms = orderAtoms(atoms)

if __name__=='__main__':
    unittest.main()
